const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const matter_parties = sequelize.define(
    'matter_parties',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

party_role: {
        type: DataTypes.ENUM,
      
      

        values: [

"plaintiff",


"defendant",


"petitioner",


"respondent",


"witness",


"judge",


"attorney",


"opposing_counsel",


"expert",


"provider",


"other"

        ],

      },

display_name: {
        type: DataTypes.TEXT,
      
      

      },

organization_name: {
        type: DataTypes.TEXT,
      
      

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

address: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  matter_parties.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity































//end loop



    db.matter_parties.belongsTo(db.matters, {
      as: 'matter',
      foreignKey: {
        name: 'matterId',
      },
      constraints: false,
    });




    db.matter_parties.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.matter_parties.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return matter_parties;
};


